<?php
/**
*
* @package phpBB3 - Facebook Connect MOD
* @version $Id: fbconnect.php 9 2009-08-02 11:41Z DeViAnThans3 $
* @copyright (c) 2009 DeViAnThans3
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
ini_set('display_errors',1);
error_reporting(E_ALL);

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include_once($phpbb_root_path . 'includes/functions_fbconnect.' . $phpEx);
include_once($phpbb_root_path . 'includes/functions_user.' . $phpEx);


require_once($phpbb_root_path . 'includes/facebook-platform/php/facebook.'.$phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup(); 
$user->add_lang(array('common', 'ucp', 'mods/fbconnect'));

// MOD Disabled? Let's tell so!
if(trim($config['fbconnect_apikey']) == "")
{
	trigger_error('Facebook Connect is disabled! You can not visit this page.');
}
// echo " "; // We don't like 500 Server Internal Error, do we?! :)

// Facebook API stuff
$facebook = new Facebook($config['fbconnect_apikey'], $config['fbconnect_appsecret']);
try {
    $user_id = $facebook->require_login();
}catch(FacebookRestClientException $e)
{
    trigger_error('A problem occured while contacting Facebook. Please try again.');
}
$fbid = $user_id;

// First time registration - handle registration!
if(isset($_POST['reg']))
{
    if(request_var('linktype','') == "exist")
    {
		if($config['fbconnect_autolang'] == 1)
		{
			try {
                $uinfo = $facebook->api_client->users_getInfo($user_id, 'last_name, first_name, pic_square, profile_url, locale');
			}catch(FacebookRestClientException $e)
            {
                trigger_error('A problem occured while contacting Facebook. Please try again.');
            }
            $user->lang_name = get_valid_lang($uinfo[0]['locale']);
			$user->add_lang(array('common','mods/fbconnect')); 
		}
        login_box('fbconnect.php?exist=1&amp;fbid='.$user_id,$user->lang['FBCONNECT_IDENTIFY'],'',false,false);
    }else{
        try {
            $uinfo = $facebook->api_client->users_getInfo($user_id, 'last_name, first_name, '.$config['fbconnect_avatartype'].', profile_url, timezone, proxied_email, current_location, interests, profile_blurb, birthday_date, locale');
        }catch(FacebookRestClientException $e)
        {
            trigger_error('A problem occured while contacting Facebook. Please try again.');
        }
        //print_r($uinfo);die(); 
		if($config['fbconnect_autolang'] == 1)
		{
			$user->lang_name = get_valid_lang($uinfo[0]['locale']);
			$user->add_lang(array('common','ucp','mods/fbconnect')); 
		}
		$validinfo = validate_username(request_var('username',''));
		
		if($config['fbconnect_askpassword'] == 1)
		{
			$pwvalidinfo = validate_password(request_var('password',''));
			if($pwvalidinfo == false)
			{
				$pwvalidinfo = validate_string(request_var('password',''), false, $config['min_pass_chars'], $config['max_pass_chars']);
			}
		}else{
			$pwvalidinfo = false;
		}
		
        if($validinfo != false || $pwvalidinfo != false)
        {	
            // An username error occured!
            $error = ($validinfo!=false) ? $user->lang[$validinfo.'_USERNAME'] : "";
			$pwerr = (empty($user->lang[$pwvalidinfo . '_PASSWORD'])) ? $pwvalidinfo : $pwvalidinfo . '_PASSWORD';
			$pwerror = ($pwvalidinfo!=false) ? $user->lang[$pwerr] : "";
            
            $template->assign_vars(array(
                'FBNAME'    => $uinfo[0]['first_name'] . " " . $uinfo[0]['last_name'],
                'FBPIC_URL' => $uinfo[0]['pic_square'],
                'ERROR' => $error,
				'PWERROR' => $pwerror,
                'SUGGESTED_USERNAME' => request_var('username',''),
				'ASK_PASSWORD' => ($config['fbconnect_askpassword'] == 0) ? false : true
            ));

            page_header("Facebook Connect");

            $template->set_filenames(array(
                'body' => 'fbconnect_body.html')
            );
            //make_jumpbox(append_sid("{$phpbb_root_path}viewforum.$phpEx"));

            page_footer();
        }
		
		if($config['fbconnect_askpassword'] == 1)
		{
			$password = request_var('password', '');
		}else{
			$password = time() . $user_id;
		}
        $user_row = array(
                        'username'                => utf8_normalize_nfc(request_var('username', '', true)),
                        'user_password'            => phpbb_hash($password),
                        'user_email'            => $uinfo[0]['proxied_email'],
                        'group_id'                => $config['fbconnect_usergroup'],
                        'user_timezone'            => (float) $uinfo[0]['timezone'],
                        'user_dst'                => 0,
                        'user_lang'                => get_valid_lang($uinfo[0]['locale']),
                        'user_type'                => USER_NORMAL,
                        'user_actkey'            => '',
                        'user_ip'                => $user->ip,
                        'user_regdate'            => time(),
                        'user_inactive_reason'    => 0,
                        'user_inactive_time'    => 0,
						'user_allow_viewemail'	=> 0,
                    );
                    
        // custom profile fields, let's say there are none!
        $cp_data = array();
        $user_id=0;
        $user_id = user_add($user_row, $cp_data); // Add user
        if($user_id>0)
        {
            link_user($user_id, $fbid, intval($config['fbconnect_askpassword'])); // Link user
        }
		
		// Add friends
		try {
            $friends = $facebook->api_client->friends_get();
        }catch(FacebookRestClientException $e)
        {
            trigger_error('A problem occured while contacting Facebook. Please try again.');
        }
        
        if(is_array($friends))
        {
		    connect_friends($user_id, $friends);
        }
        
        $result = $user->session_create($user_id, 0, 0, 1);
        
        header("Location: index.php");
    }
}elseif(isset($_GET['exist'])){
    // Link an existing user!
	link_user($user->data['user_id'], $fbid, 1); // Link user
	
	// Add friends
    try {
	   $friends = $facebook->api_client->friends_get();
    }catch(FacebookRestClientException $e)
    {
        trigger_error('A problem occured while contacting Facebook. Please try again.');
    }
    if(is_array($friends))
    {
	    connect_friends($user->data['user_id'], $friends);
    }
	
	// Add to user group if necessary
	add_exist_group($user->data['user_id']);
	
    trigger_error($user->lang['FBCONNECT_COMPLETE']);
}else{
    
    $sql = 'SELECT user_id
            FROM ' . FBIDS_TABLE . "
            WHERE fb_id = '" . $db->sql_escape($user_id) . "'";
    $result = $db->sql_query($sql);
    $row = $db->sql_fetchrow($result);
    $db->sql_freeresult($result);

    if ($row)   // User is registered already, let's log him in!
    {
		// Don't allow banned users to log in, obviously!
		if($user->check_ban($row['user_id']))
		{
			trigger_error('You are banned.'); 
		}
        
        $persist_login = false;
        $viewonline = true;
        
        if(isset($_GET['autologin']))
        {
            $persist_login = true;
        }
        
        if(isset($_GET['viewonline']))
        {
            $viewonline = false;
        }
		
        $result = $user->session_create($row['user_id'], 0, $persist_login, $viewonline);
        
		if(isset($_GET['redir'])) 
		{
			header("Location: ".$_GET['redir']);
		}else{
			header("Location: index.php");
		}
    }else{      // First time log in, ask for an username!
		try {
            $uinfo = $facebook->api_client->users_getInfo($user_id, 'last_name, first_name, pic_square, profile_url, locale');
        }catch(FacebookRestClientException $e)
        {
            trigger_error('A problem occured while contacting Facebook. Please try again.');
        }
        if($config['fbconnect_autolang'] == 1)
		{
			$user->lang_name = get_valid_lang($uinfo[0]['locale']);
			$user->add_lang(array('common','mods/fbconnect')); 
		}
        $template->assign_vars(array(
            'FBNAME'    => $uinfo[0]['first_name'] . " " . $uinfo[0]['last_name'],
            'FBPIC_URL' => $uinfo[0]['pic_square'],
            'SUGGESTED_USERNAME' => (strstr($uinfo[0]['profile_url'],".php")) ? "" : substr($uinfo[0]['profile_url'],24),
			'ASK_PASSWORD' => ($config['fbconnect_askpassword'] == 0) ? false : true
        ));

        page_header("Facebook Registration");

        $template->set_filenames(array(
            'body' => 'fbconnect_body.html')
        );
        //make_jumpbox(append_sid("{$phpbb_root_path}viewforum.$phpEx"));

        page_footer();
    }
}
?>