<?php
/**
*
* @package acp
* @version $Id: acp_board.php 8911 2008-09-23 13:03:33Z acydburn $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
* @todo add cron intervals to server settings? (database_gc, queue_interval, session_gc, search_gc, cache_gc, warnings_gc)
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_fbconnect
{
	var $u_action;
	var $new_config = array();

	function main($id, $mode)
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;
        
        $disabledUserColumns = array("user_id","user_type","group_id","user_permissions","user_perm_from","user_ip","user_regdate","username","username_clean","user_password","user_passchg","user_pass_convert","user_email","user_email_hash","user_lastvisit","user_lastmark","user_last_posttime","user_lastpage","user_last_confirm_key","user_last_search","user_warnings","user_last_warning","user_login_attempts","user_inactive_reason","user_inactive_time","user_posts","user_lang","user_timezone","user_dst","user_dateformat","user_style","user_rank","user_colour","user_new_privmsg","user_unread_privmsg","user_last_privmsg","user_message_rules","user_full_folder","user_emailtime","user_topic_show_days","user_topic_sortby_type","user_topic_sortby_dir","user_post_show_days","user_post_sortby_type","user_post_sortby_dir","user_notify","user_notify_pm","user_notify_type","user_allow_pm","user_allow_viewonline","user_allow_viewemail","user_allow_massemail","user_options","user_avatar","user_avatar_type","user_avatar_height","user_avatar_width","user_sig_bbcode_uid","user_sig_bbcode_bitfield","user_actkey","user_newpasswd","user_form_salt");

		$user->add_lang('acp/fbconnect');
		$user->add_lang('acp/groups');

		$action	= request_var('action', '');
		$submit = (isset($_POST['submit'])) ? true : false;

		$form_key = 'acp_fbconnect';
		add_form_key($form_key);

		/**
		*	Validation types are:
		*		string, int, bool,
		*		script_path (absolute path in url - beginning with / and no trailing slash),
		*		rpath (relative), rwpath (realtive, writable), path (relative path, but able to escape the root), wpath (writable)
		*/
		switch ($mode)
		{
			case 'settings':
				$display_vars = array(
					'title'	=> 'ACP_FBCONNECT_SETTINGS',
					'vars'	=> array(
						'legend1'				=> 'ACP_FBCONNECT_BASIC_SETTINGS',
						'fbconnect_apikey'				=> array('lang' => 'FBCONNECT_API_KEY',				'validate' => 'string',	'type' => 'text:40:255', 'explain' => true),
						'fbconnect_appsecret'	=> array('lang' => 'FBCONNECT_APP_SECRET',				'validate' => 'string',	'type' => 'text:40:255', 'explain' => false),
						'legend2'			=> 'ACP_FBCONNECT_FEATURES',
						'fbconnect_dataimport' =>array('lang' => 'FBCONNECT_ENABLE_DATA_IMPORT',				'validate' => 'int',	'type' => 'radio:yes_no', 'explain' => true),
						'fbconnect_friendimport' =>array('lang' => 'FBCONNECT_ENABLE_FRIEND_IMPORT',				'validate' => 'int',	'type' => 'radio:yes_no', 'explain' => true),
						'fbconnect_autolang' =>array('lang' => 'FBCONNECT_AUTO_LANG_DETECTION',				'validate' => 'int',	'type' => 'radio:yes_no', 'explain' => true),
						'legend3'			=> 'ACP_FBCONNECT_ADVANCED_SETTINGS',
						'fbconnect_avatartype'	=> array('lang' => 'FBCONNECT_AVATAR_TYPE',	'validate' => 'string',	'type' => 'select', 'method' => 'avatartype_select', 'explain' => false),
						'fbconnect_forceavatar'	=>array('lang' => 'FBCONNECT_FORCE_AVATAR_IMPORT',				'validate' => 'int',	'type' => 'radio:yes_no', 'explain' => true),
						'fbconnect_usergroup'	=> array('lang' => 'FBCONNECT_DEFAULT_USERGROUP',	'validate' => 'int',	'type' => 'select', 'method' => 'usergroup_select', 'explain' => true),
						'fbconnect_existgroup'	=>array('lang' => 'FBCONNECT_APPLYGROUP_FOR_EXISTING',				'validate' => 'int',	'type' => 'radio:yes_no', 'explain' => true),
						'fbconnect_askpassword'	=>array('lang' => 'FBCONNECT_ASK_FOR_PASSWORD',				'validate' => 'int',	'type' => 'radio:yes_no', 'explain' => true),
						'fbconnect_dologout'	=>array('lang' => 'FBCONNECT_FBLOGOUT',				'validate' => 'int',	'type' => 'radio:yes_no', 'explain' => true),
					)  
				);
                
                if (isset($display_vars['lang']))
                {
                    $user->add_lang($display_vars['lang']);
                }

                $this->new_config = $config;
                $cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
                $error = array();

                // We validate the complete config if whished
                validate_config_vars($display_vars['vars'], $cfg_array, $error);

                if ($submit && !check_form_key($form_key))
                {
                    $error[] = $user->lang['FORM_INVALID'];
                }
                // Do not write values if there is an error
                if (sizeof($error))
                {
                    $submit = false;
                }

                // We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
                foreach ($display_vars['vars'] as $config_name => $null)
                {
                    if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
                    {
                        continue;
                    }

                    if ($config_name == 'auth_method')
                    {
                        continue;
                    }

                    $this->new_config[$config_name] = $config_value = $cfg_array[$config_name];

                    if ($config_name == 'email_function_name')
                    {
                        $this->new_config['email_function_name'] = trim(str_replace(array('(', ')'), array('', ''), $this->new_config['email_function_name']));
                        $this->new_config['email_function_name'] = (empty($this->new_config['email_function_name']) || !function_exists($this->new_config['email_function_name'])) ? 'mail' : $this->new_config['email_function_name'];
                        $config_value = $this->new_config['email_function_name'];
                    }

                    if ($submit)
                    {
                        set_config($config_name, $config_value);
                    }
                }

                if ($submit)
                {
                    add_log('admin', 'LOG_CONFIG_' . strtoupper($mode));

                    trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
                }

                $this->tpl_name = 'acp_fbconnect';
                $this->page_title = $display_vars['title'];

                $template->assign_vars(array(
                    'L_TITLE'            => $user->lang[$display_vars['title']],
                    'L_TITLE_EXPLAIN'    => $user->lang[$display_vars['title'] . '_EXPLAIN'],

                    'S_ERROR'            => (sizeof($error)) ? true : false,
                    'ERROR_MSG'            => implode('<br />', $error),

                    'U_ACTION'            => $this->u_action)
                );

                // Output relevant page
                foreach ($display_vars['vars'] as $config_key => $vars)
                {
                    if (!is_array($vars) && strpos($config_key, 'legend') === false)
                    {
                        continue;
                    }

                    if (strpos($config_key, 'legend') !== false)
                    {
                        $template->assign_block_vars('options', array(
                            'S_LEGEND'        => true,
                            'LEGEND'        => (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
                        );

                        continue;
                    }

                    $type = explode(':', $vars['type']);

                    $l_explain = '';
                    if ($vars['explain'] && isset($vars['lang_explain']))
                    {
                        $l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
                    }
                    else if ($vars['explain'])
                    {
                        $l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
                    }

                    $content = build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars);

                    if (empty($content))
                    {
                        continue;
                    }

                    $template->assign_block_vars('options', array(
                        'KEY'            => $config_key,
                        'TITLE'            => (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
                        'S_EXPLAIN'        => $vars['explain'],
                        'TITLE_EXPLAIN'    => $l_explain,
                        'CONTENT'        => $content,
                        )
                    );

                    unset($display_vars['vars'][$config_key]);
                }
			break;
            
            

			default:
				trigger_error('NO_MODE', E_USER_ERROR);
			break;
		}

		

	}
	
	/**
	* Select usergroup
	*/
	function usergroup_select($value, $key = '') 
	{
		global $user, $db;
		$return = "";
		
		$sql = "SELECT group_id, group_name, group_type FROM " . GROUPS_TABLE;
		$result = $db->sql_query($sql);
		
		while($group = $db->sql_fetchrow($result))
		{
			if($group['group_id'] == $value)
			{
				$selected = " selected=\"selected\"";
			}else{
				$selected = "";
			}
			
			$group_name = ($group['group_type'] == GROUP_SPECIAL) ? $user->lang['G_' . $group['group_name']] : $group['group_name'];

			$return .= "<option value=\"{$group['group_id']}\"$selected>".$group_name."</option>\n";
		}
		return $return;
	}
	
	/**
	* Select avatar type
	*/
	function avatartype_select($value, $key = '') 
	{
		global $user;
		$return = "";
		$avatartypes = array();
		$avatartypes['pic_square'] = $user->lang['FBCONNECT_AVATAR_SQUARE'];
		$avatartypes['pic_square_with_logo'] = $user->lang['FBCONNECT_AVATAR_SQUARE_LOGO'];
		$avatartypes['pic_small'] = $user->lang['FBCONNECT_AVATAR_SMALL'];
		$avatartypes['pic_small_with_logo'] = $user->lang['FBCONNECT_AVATAR_SMALL_LOGO'];
		$avatartypes['pic'] = $user->lang['FBCONNECT_AVATAR_NORMAL'];
		$avatartypes['pic_with_logo'] = $user->lang['FBCONNECT_AVATAR_NORMAL_LOGO'];
		$avatartypes['pic_big'] = $user->lang['FBCONNECT_AVATAR_BIG']; 
		$avatartypes['pic_big_logo'] = $user->lang['FBCONNECT_AVATAR_BIG_LOGO']; 
		
		foreach($avatartypes as $key => $description)
		{
			if($key == $value)
			{
				$selected = " selected=\"selected\"";
			}else{
				$selected = "";
			}
			
			$return .= "<option value=\"{$key}\"$selected>".$description."</option>\n";
		}
		return $return;
	}

	
}

?>