<?php
/**
*
* @package acm
* @version $Id: cache.php 8691 2008-07-28 13:26:20Z acydburn $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
//ini_set('display_errors',1);
//error_reporting(E_ALL);
/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* Class for grabbing/handling cached entries, extends acm_file or acm_db depending on the setup
* @package acm
*/
class fbdata extends acm
{
	/**
	* Get config values
	*/
	function obtain_fbdata($fbid)
	{
		global $db, $user, $phpbb_root_path, $phpEx, $config;
		if (($fbdata = $this->get('_fb_' . $user->session_id)) !== false)
		{
            if(is_array(@$fbdata[$fbid]))
            {
                return $fbdata[$fbid]; // Data is cached, let's return!
            }
		}
            
        // No data is cached, or at least not the data we requested. Let's look up Facebook!
        require_once($phpbb_root_path . 'includes/facebook-platform/php/facebook.'.$phpEx);
        $facebook = new Facebook($config['fbconnect_apikey'], $config['fbconnect_appsecret']);
   
        try
        {
            $uinfo = $facebook->api_client->users_getInfo($fbid, 'last_name, first_name, '.$config['fbconnect_avatartype'].', profile_url, timezone, proxied_email, current_location, interests, profile_blurb, birthday_date, locale'); // One call for all info to be fetched. This is quicker.
        }
        catch(FacebookRestClientException $e)
        {
            return false; // Error occured, let's return a boolean.
        }
        
        if(!is_array($uinfo))
        {
            return false; // No usable info was returned, let's return a boolean.
        }
        
        if(!is_array($fbdata))
        {
            $fbdata = array();
        }
        $fbdata[$fbid] = $uinfo[0];

        $this->put('_fb_' . $user->session_id, $fbdata, 3600);
		
		return $fbdata[$fbid];
	}
}

?>